unit UnidadProcedimientos;

interface
  uses inifiles, sysutils, ShlObj, ActiveX, Windows, ShellCtrls,
      controls, classes, registry, db, dialogs, forms, variants, IdSMTP,
      IdMessage, dateutils, shellapi, WinSvc, Types, StdCtrls;

  function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
  function leCadINI (clave, cadena : string; defecto : String) : String;
  function leNumINI (clave, cadena : string; defecto : Integer) : Integer;
  procedure esCadINI (clave, cadena : string; valor : String);
  procedure esBoolINI (clave, cadena : string; valor : Boolean);
  procedure esNumINI (clave, cadena : string; valor : Integer);
  function SeleccionarCarpeta (titulo : string) : string;
  function encriptar(aStr: String; aKey: Integer): String;
  function desencriptar(aStr: String; aKey: Integer): String;
  function obtenerCadenaRegistro (claveInicial : Cardinal; clave : string; valor : string) : string;
  procedure obtenerDatosODBC (odbc : string; sistema : boolean;
      var bd : string; var tipo : string; var descripcion : string;
      var controlador : string; var servidor : string;
      var listener : string; var usuario : string);
  function ConectarServidorEmail (servidor : string; usuario : string; puerto : integer) : boolean;
  function enviarEmail (servidor : string; usuario : string; contrasena : string;
    puerto : integer; asunto : string; mensaje : string; conAutenticacion : boolean;
    emisor : string; nombreEmisor : string; destinatario : string; cc : string;
    cco : string) : boolean;
  function anoFecha (fecha : TDate) : Integer;
  function marcarTelefono (telefono : string; puerto : string) : boolean;
  procedure colgarLlamada ();
  function DlgElegirDirectorio(subtitulo: string;
     nuevoEstilo: boolean) : string;
  function reemplazarTexto (cadena, textoAreemplazar, textoNuevo : string) : string;
  function recrearEstructuraCarpetas (lsCarpetas : TStringList;
      rutaOrigen : string) : string;
  procedure horasMinutosSegundos (numSegundos : integer; var horas,
      minutos, segundos : integer);
  function fechaHoraMinutosSegundos(fecha : TDateTime) : string;
  function extraerSoloNombreFichero (fichero : string) : string;
  function detenerServicio(nombreEquipo, nombreServicio : String) : Boolean;
  function tamanoFichero (sFileToExamine: string) : Integer;
  function tamanoFichero2(const FileName: string): TULargeInteger;
  function tamanoFichero3 (Handle: THandle): Int64;
  function comprobarHoraIgual (hora1 : TTime; hora2 : TTime;
      compMilisegundos : boolean; compSegundos : boolean;
      compMinutos : boolean) : boolean;
  procedure quitarEjecutarInicio ();
  procedure ejecutarInicio ();
  procedure subirElementoLista (lista : TListBox; subir : boolean);
  function obtenerFechasFichero (const fichero: string;
      var fechaCreacion : TDateTime;
      var fechaUltimoAcceso : TDateTime;
      var fechaModificacion : TDateTime): Boolean;
  function buscarElementoLista (elemento : string; lista : TStrings) : boolean;
  function obtenerNombreFicheroSinExtension (fichero : string) : string;
  procedure obtenerDatosUnidad (unidad : string);
  function buscarCarpetaRaiz (rutaCar : string; carpetaRaizCar : string) : boolean;
  function buscarCarpetaRaizLista (elemento : string; lista : TStrings) : boolean;
  procedure detenerServicios (lsServicios : TStrings);
  function iniciarServicio (sMachine, sService: String) : Boolean;
  procedure iniciarServicios (lsServicios : TStrings);
  function cambiarAtributo (fichero : string; activar : boolean) : boolean;
  function archivoListoArchivar (fichero : string) : Boolean;

var

  //para marcacin telefnica
  ficheroComunicacion : THandle;
  listaLog : TStringList;
  numFicherosCopiados : integer;
  numFicherosNoCopiados : integer;
  numFicheroExcluidos : integer;
  numCarpetasExcluidas : integer;
  bytesCopiados : Largeint;
  bytesNoCopiadosExclusiones : Largeint;

  etiqueta, tipoFicheros, numeroSerie : string;
  longitudMaximaFichero : DWORD;
  sectoresPorCluster : DWORD;
  bytesPorSector : DWORD;
  numeroClusterLibres : DWORD;
  numeroTotalCluster : DWORD;
  espacioLibreDisco : double;
  espacioOcupadoDisco : double;
  espacioTotalDisco : double;

const
 BIF_NEWDIALOGSTYLE = $40;

implementation

uses UnidadMenuPrincipal;


var
  compEnvioEmail : TIdSMTP;

function archivoListoArchivar (fichero : string) : Boolean;
var
  atributos : word;
begin
  atributos := GetFileAttributes(pchar(fichero));
  result := (atributos and FILE_ATTRIBUTE_ARCHIVE) > 0;
end;


function cambiarAtributo (fichero : string; activar : boolean) : boolean;
var
  resultado : boolean;
  atributos: Cardinal;
  atributoNumero : DWORD;
begin
  resultado := false;

  atributos := GetFileAttributes(PChar(fichero));
  atributoNumero := FILE_ATTRIBUTE_ARCHIVE;

  if activar then
  begin
    if (atributos and atributoNumero) > 0 then
      Result := false
    else
      resultado := SetFileAttributes (PChar(fichero), atributos + atributoNumero);
  end
  else
  begin
    if (atributos and atributoNumero) > 0 then
      resultado := SetFileAttributes (PChar(fichero), atributos - atributoNumero)
    else
      Result := false;
  end;

  Result := resultado;
end;



function iniciarServicio (sMachine, sService: String) : Boolean;
var
  schm,
  schs: SC_Handle;
  ss: TServiceStatus;
  psTemp: PChar;
  dwChkP: DWord;
begin
  ss.dwCurrentState := 0;
  schm := OpenSCManager(PChar(sMachine), nil, SC_MANAGER_CONNECT);
  if (schm>0) then
  begin
    schs := OpenService(schm, PChar(sService), SERVICE_START or
      SERVICE_QUERY_STATUS);
    if (schs>0) then
    begin
      psTemp := nil;
      if (StartService(schs, 0, psTemp)) then
        if (QueryServiceStatus(schs, ss)) then
          while (SERVICE_RUNNING<>ss.dwCurrentState) do
          begin
            dwChkP := ss.dwCheckPoint;
            Sleep(ss.dwWaitHint);
            if (not QueryServiceStatus(schs, ss)) then
              Break;
            if (ss.dwCheckPoint < dwChkP) then
              Break;
          end;
      CloseServiceHandle(schs);
    end;
    CloseServiceHandle(schm);
  end;
  Result := SERVICE_RUNNING=ss.dwCurrentState;
end;
  

  
procedure detenerServicios (lsServicios : TStrings);
var
  i : integer;
begin
  for i := 0 to lsServicios.Count - 1 do
    detenerServicio('\\', lsServicios.Strings[i]);
end;

procedure iniciarServicios (lsServicios : TStrings);
var
  i : integer;
begin
  for i := 0 to lsServicios.Count - 1 do
    iniciarServicio('\\', lsServicios.Strings[i]);
end;


function buscarCarpetaRaiz (rutaCar : string; carpetaRaizCar : string) : boolean;
begin
  result := AnsiUpperCase (Copy(rutaCar, 1, length(carpetaRaizCar))) = AnsiUpperCase (carpetaRaizCar);
end;

function buscarSubcarpeta (rutaCar : string; carpetaRaizCar : string) : boolean;
begin
  result := AnsiUpperCase (Copy(rutaCar, 1, length(carpetaRaizCar))) = AnsiUpperCase (carpetaRaizCar);
end;


procedure obtenerDatosUnidad (unidad : string);
var
  VolumeName : array [0..255] of Char;
  FileSystemType : array [0..255] of Char;
  SerialNum : DWORD;
  MaxFilenameLength : DWORD;
  Flags : DWORD;
  vNumeroClusterLibres, vbytesPorSector, vsectoresPorCluster, vnumeroTotalCluster : Double;
begin
  //etiqueta, nmero serie, sistema archivos, longitud mxima fichero
  if (GetVolumeInformation(PChar(unidad), VolumeName,  256,  @SerialNum,
      MaxFilenameLength, Flags, FileSystemType, 256))then
  begin
    etiqueta := VolumeName;
    tipoFicheros := FileSystemType;
    numeroSerie := IntToHex(HiWord(SerialNum), 4) + ' - ' +
        IntToHex(LoWord(SerialNum), 4) ;
    LongitudMaximaFichero := MaxFilenameLength;
  end
  else
  begin
    etiqueta := '';
    tipoFicheros := '';
    LongitudMaximaFichero := 0;
  end;

  //sectores, cluster, ...
  if Windows.GetDiskFreeSpace(pchar(unidad), sectoresPorCluster, bytesPorSector,
      numeroClusterLibres, numeroTotalCluster) then
  begin
    vNumeroClusterLibres := numeroClusterLibres;
    vbytesPorSector := bytesPorSector;
    vsectoresPorCluster := sectoresPorCluster;
    vnumeroTotalCluster := numeroTotalCluster;
    espacioLibreDisco := vNumeroClusterLibres * vbytesPorSector * vsectoresPorCluster;
    espacioTotalDisco := vnumeroTotalCluster * vbytesPorSector * vsectoresPorCluster;
    espacioOcupadoDisco := espacioTotalDisco - espacioLibreDisco;
  end
  else
  begin
    espacioLibreDisco := 0;
    espacioTotalDisco := 0;
    espacioOcupadoDisco := 0;
    sectoresPorCluster := 0;
    bytesPorSector := 0;
    numeroClusterLibres := 0;
    numeroTotalCluster := 0;
  end;
end;

function obtenerNombreFicheroSinExtension (fichero : string) : string;
var
  i : integer;
  nombreFichero : string;
begin
  nombreFichero := '';
  for i := 1 to Length (fichero) - Length (ExtractFileExt (fichero)) do
    nombreFichero := nombreFichero + fichero[i];
  result := nombreFichero;
end;
  
function buscarElementoLista (elemento : string; lista : TStrings) : boolean;
var
  i : integer;
begin
  result := false;
  for i := 0 to lista.count - 1 do
  begin
    if AnsiUpperCase (lista[i]) = (AnsiUpperCase(elemento)) then
    begin
      Result := true;
      Break;
    end;
  end;
end;  

function buscarCarpetaRaizLista (elemento : string; lista : TStrings) : boolean;
var
  i, posElementoBus : integer;
  esCarpetaRaiz : boolean;
begin
  result := false;
  for i := 0 to lista.count - 1 do
  begin
    esCarpetaRaiz := false;
    if (Copy(lista[i], 1, 2) = '\\') or (Copy(lista[i], 1, 2) = '//') then
      esCarpetaRaiz := true;
    if (Copy(lista[i], 2, 2) = ':\') or (Copy(lista[i], 2, 2) = ':/') then
      esCarpetaRaiz := true;

    if esCarpetaRaiz then
    begin
      if buscarCarpetaRaiz (ExcludeTrailingPathDelimiter(elemento),
           ExcludeTrailingPathDelimiter (lista[i])) then
      begin
        Result := true;
        Break;
      end;
    end
    else
    begin
      posElementoBus := Pos (lista[i], elemento);
      if posElementoBus > 0 then
      begin
        if ((Copy (IncludeTrailingPathDelimiter (elemento), posElementoBus - 1, 1) = '\') or
            (Copy (IncludeTrailingPathDelimiter (elemento), posElementoBus - 1, 1) = '/')) and
            ((Copy (IncludeTrailingPathDelimiter (elemento), posElementoBus + Length (lista[i]), 1) = '\') or
            (Copy (IncludeTrailingPathDelimiter (elemento), posElementoBus + Length (lista[i]), 1) = '/') ) then
        begin
          Result := true;
          Break;
        end;
      end;
    end;
  end;
end;


function obtenerFechasFichero (const fichero: string;
    var fechaCreacion : TDateTime;
    var fechaUltimoAcceso : TDateTime;
    var fechaModificacion : TDateTime): Boolean;
var
  h: THandle;
  Info1, Info2, Info3: TFileTime;
  SysTimeStruct: SYSTEMTIME;
  TimeZoneInfo: TTimeZoneInformation;
  Bias: Double;
begin
  Result := False;
  Bias   := 0;
  h      := FileOpen(fichero, fmOpenRead or fmShareDenyNone);
  if h > 0 then
  begin
    try
      if GetTimeZoneInformation(TimeZoneInfo) <> $FFFFFFFF then
        Bias := TimeZoneInfo.Bias / 1440; // 60x24
      GetFileTime(h, @Info1, @Info2, @Info3);
      if FileTimeToSystemTime(Info1, SysTimeStruct) then
        fechaCreacion := SystemTimeToDateTime(SysTimeStruct) - Bias;
      if FileTimeToSystemTime(Info2, SysTimeStruct) then
        fechaUltimoAcceso := SystemTimeToDateTime(SysTimeStruct) - Bias;
      if FileTimeToSystemTime(Info3, SysTimeStruct) then
        fechaModificacion := SystemTimeToDateTime(SysTimeStruct) - Bias;
      Result := True;
    finally
      FileClose(h);
    end;
  end;
end;  

procedure subirElementoLista (lista : TListBox; subir : boolean);
var
  posicionActual : integer;
begin
  posicionActual := lista.ItemIndex;
  if posicionActual <> -1 then
  begin
    if subir then
    begin
      if posicionActual > 0 then
      begin
        lista.Items.Move(posicionActual, posicionActual - 1);
        lista.ItemIndex := posicionActual - 1;
      end;
    end;
    if not subir then
    begin
      if posicionActual < lista.Count - 1 then
      begin
        lista.Items.Move(posicionActual, posicionActual + 1);
        lista.ItemIndex := posicionActual + 1;
      end;
    end;
  end;
end;

procedure quitarEjecutarInicio ();
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', false);
  reg.DeleteValue(Application.Title);
  reg.CloseKey;
  reg.Free;
end;

procedure ejecutarInicio ();
var
  reg : tregistry;
begin
  Reg := TRegistry.Create(KEY_WRITE);
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run', True) then
    begin
      try
        Reg.WriteString(Application.Title,
            ExtractFilePath(ParamStr(0)) + ExtractFileName(ParamStr(0)));
      except
        Reg.CloseKey;
        raise;
      end;
    end;
    Reg.CloseKey;
  finally
    Reg.Free;
  end;
end;

function comprobarHoraIgual (hora1 : TTime; hora2 : TTime;
    compMilisegundos : boolean; compSegundos : boolean;
    compMinutos : boolean) : boolean;
var
  horas, minutos, segundos, milisegundos : Word;
  horasPro, minutosPro, segundosPro, milisegundosPro : Word;
  iguales : boolean;
begin
  DecodeTime(hora1, horas, minutos, segundos, milisegundos);
  DecodeTime(hora2, horasPro, minutosPro, segundosPro, milisegundosPro);
  iguales := horas = horasPro;
  if iguales and compMinutos then
  begin
    iguales := minutos = minutosPro;
    if iguales and compSegundos then
    begin
      iguales := segundos = segundosPro;
      if iguales and compMilisegundos then
        iguales := milisegundos = milisegundosPro;
    end;
  end;
  Result := iguales;
end;


function detenerServicio(nombreEquipo, nombreServicio : String) : Boolean;
var
  schm,
  schs: SC_Handle;
  ss: TServiceStatus;
  dwChkP: DWord;
begin
  schm := OpenSCManager(PChar(nombreEquipo), nil, SC_MANAGER_CONNECT);
  if (schm>0) then
  begin
    schs := OpenService(schm, PChar(nombreServicio), SERVICE_STOP or
      SERVICE_QUERY_STATUS);
    if (schs>0) then
    begin
      if (ControlService(schs, SERVICE_CONTROL_STOP, ss)) then
        if (QueryServiceStatus(schs, ss)) then
          while (SERVICE_STOPPED<>ss.dwCurrentState) do
          begin
            dwChkP := ss.dwCheckPoint;
            Sleep(ss.dwWaitHint);
            if (not QueryServiceStatus(schs, ss)) then
              Break;
            if (ss.dwCheckPoint < dwChkP) then
              Break;
          end;
      CloseServiceHandle(schs);
    end;
    CloseServiceHandle(schm);
  end;
  Result := SERVICE_STOPPED=ss.dwCurrentState;
end;


function extraerSoloNombreFichero (fichero : string) : string;
var
  ficheroFinal : string;
begin
  ficheroFinal := ExtractFileName(fichero);
  //si el fichero no tiene extensin
  if ExtractFileExt(ficheroFinal) <> '' then
    ficheroFinal := copy (ficheroFinal, 1, pos (ExtractFileExt (ficheroFinal), ficheroFinal) - 1);
  Result := ficheroFinal;
end;

function fechaHoraMinutosSegundos (fecha : TDateTime) : string;
var
  ano, mes, dia, hora, minuto, segundo, milisegundo : Word;
begin
  DecodeDateTime(fecha, ano, mes, dia, hora, minuto, segundo, milisegundo);
  Result := inttostr(ano) + '-' + inttostr(mes) + '-' + inttostr(dia) +
      '-' + inttostr(hora) + '-' + inttostr(minuto) + '-' + inttostr(segundo);
end;

procedure horasMinutosSegundos (numSegundos : integer; var horas,
    minutos, segundos : integer);
begin
  horas := numSegundos div 3600;
  minutos := numSegundos div 60 mod 60;
  segundos := numSegundos mod 60;
end;

function reemplazarTexto (cadena, textoAreemplazar, textoNuevo : string) : string;
var
  aPos : Integer;
begin
  aPos := Pos(textoAreemplazar, Cadena);
  Result := '';
  while (aPos <> 0) do
  begin
    Result := Result + Copy(Cadena, 1, aPos - 1) + textoNuevo;
    Delete(Cadena, 1, aPos + Length(textoAreemplazar) - 1);
    aPos := Pos(textoAreemplazar, Cadena);
  end;
  Result := Result + Cadena;
end;

function recrearEstructuraCarpetas (lsCarpetas : TStringList;
    rutaOrigen : string) : string;
var
  i : integer;
  carpetaNueva : string;
  carpetaAnterior : string;
begin
  carpetaAnterior := rutaOrigen;
  for i := 0 to lsCarpetas.Count - 1 do
  begin
    carpetaNueva := carpetaAnterior + '\' + lsCarpetas[i];
    if not DirectoryExists(carpetaNueva) then
      MkDir(carpetaNueva);
    carpetaAnterior := carpetaNueva;
  end;
  result := carpetaAnterior;
end;


function marcarTelefono (telefono : string; puerto : string) : boolean;
var
  numeroTelefono : string;
  numeroBytesEscritos : cardinal;
begin
  numeroTelefono := 'ATDT ' + telefono + #13 + #10;
  ficheroComunicacion := CreateFile(PChar(puerto), GENERIC_WRITE, 0, nil, OPEN_EXISTING,
      FILE_ATTRIBUTE_NORMAL, 0);
  if ficheroComunicacion = INVALID_HANDLE_VALUE then
    Result := false
  else
  begin
    numeroBytesEscritos := 0;
    if WriteFile (ficheroComunicacion, PChar(numeroTelefono)^, Length(numeroTelefono),
        numeroBytesEscritos, nil) = false then
      Result := false
    else
      result := true;
  end;
end;

procedure colgarLlamada ();
begin
  try
    CloseHandle(ficheroComunicacion);
  except
  end;
end;


function anoFecha (fecha : TDate) : Integer;
var
  vano, vmes, vdia : word;
begin
  DecodeDate (fecha, vano, vmes, vdia);
  result := vano;
end;

function tamanoFichero3 (Handle: THandle): Int64;
var
  i64: record
    LoDWord: LongWord;
    HiDWord: LongWord;
  end;
begin
  i64.LoDWord := GetFileSize(Handle, @i64.HiDWord);
  if (i64.LoDWord = MAXDWORD) and (GetLastError <> 0) then
    Result := 0
  else
    Result := PInt64(@i64)^;
end;

function tamanoFichero2(const FileName: string): TULargeInteger;
var
  Find: THandle;
  Data: TWin32FindData;
begin
  Result.QuadPart := 0;
  Find := FindFirstFile(PChar(FileName), Data);
  if (Find <> INVALID_HANDLE_VALUE) then
  begin
    Result.LowPart  := Data.nFileSizeLow;
    Result.HighPart := Data.nFileSizeHigh;
    Windows.FindClose(Find);
  end;
end;

function tamanoFichero (sFileToExamine: string) : Integer;
var
  SearchRec: TSearchRec;
  sgPath: string;
  inRetval, I1: Integer;
begin
  sgPath := ExpandFileName(sFileToExamine);
  try
    inRetval := FindFirst(ExpandFileName(sFileToExamine), faAnyFile, SearchRec);
    if inRetval = 0 then
      I1 := SearchRec.Size
    else
      I1 := -1;
  finally
    SysUtils.FindClose(SearchRec);
  end;
  Result := I1;
end;




//Funcin para conectar con el servidor de email
function ConectarServidorEmail (servidor : string; usuario : string; puerto : integer) : boolean;
begin
  compEnvioEmail := TIdSMTP.Create(nil);
  compEnvioEmail.host := servidor;
  compEnvioEmail.userid := usuario;
  compEnvioEmail.Port := puerto;
  try
    compEnvioEmail.connect;
    ConectarServidorEmail := true;
  except
    compEnvioEmail.Free;
    raise;
  end;
end;


//enviar email
function enviarEmail (servidor : string; usuario : string; contrasena : string;
    puerto : integer; asunto : string; mensaje : string; conAutenticacion : boolean;
    emisor : string; nombreEmisor : string; destinatario : string; cc : string;
    cco : string) : boolean;
var
  compMensaje : TIdMessage;
  envioCorrecto : boolean;
begin
  if conAutenticacion then
  begin
    compEnvioEmail.AuthenticationType := atLogin;
    compEnvioEmail.UserId := usuario;
    compEnvioEmail.Password := contrasena;
  end
  else
    compEnvioEmail.AuthenticationType := atNone;
  compMensaje := TIdMessage.Create (nil);
  compMensaje.From.Address := emisor;
  compMensaje.From.Name := nombreEmisor;
  if destinatario <> '' then
    compMensaje.Recipients.Add.Address := destinatario;
  if cc <> '' then
    compMensaje.CCList.Add.Address := cc;
  compMensaje.Body.Text := mensaje;
  compMensaje.Subject := asunto;
  if cco <> '' then
    compMensaje.BccList.Add.Address := cco;
  if emisor <> '' then
    compMensaje.ReplyTo.Add.Address := emisor;
  envioCorrecto := true;
  try
    compEnvioEmail.Send(compMensaje);
  except
    raise;
  end;
  compMensaje.Free;
  enviarEmail := envioCorrecto;
end;


function DlgElegirDirectorio(subtitulo: string;
   nuevoEstilo: boolean) : string;
 var
   BI: TBrowseInfo;
   IL: PItemIDList;
 begin
   Result := EmptyStr;
   with BI do begin
     lpfn:= nil;
     lParam:= 0;
     iImage:= 0;
     pidlRoot:= nil;
     hwndOwner:= GetActiveWindow;
     lpszTitle:= PChar(subtitulo);
     GetMem(pszDisplayName, MAX_PATH);
     ulFlags := BIF_RETURNONLYFSDIRS;
     if nuevoEstilo then
       ulFlags := ulFlags or BIF_NEWDIALOGSTYLE;
   end;

   IL := SHBrowseForFolder(BI);
   if SHGetPathFromIDList(IL, BI.pszDisplayName) then
     Result := IncludeTrailingPathDelimiter(
       StrPas(BI.pszDisplayName));
   FreeMem(BI.pszDisplayName);
   GlobalFreePtr(IL);
 end;



function SeleccionarCarpeta (titulo : string) : string;
var
  Inf: TBrowseInfo;
  Identificador: PItemIDList;
  Gestor : IMalloc;
  Carpeta : Array[0..MAX_PATH] Of Char;
  handle : THandle;
begin
  With Inf Do
  Begin
    hwndOwner := Handle;
    pidlRoot := Nil;
    pszDisplayName := Carpeta;
    lpszTitle := pchar(titulo);
    ulFlags := BIF_BROWSEINCLUDEFILES;
    lpfn := Nil;
  End;
  Identificador := SHBrowseForFolder(Inf);
  If Identificador <> Nil Then
  Begin
    SHGetPathFromIDList(Identificador, Carpeta);
    SHGetMalloc(Gestor);
    Gestor.Free(Identificador);
    SeleccionarCarpeta := Carpeta
  end;
end;


//lee un valor booleano de un fichero INI
function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readbool (clave, cadena, defecto);
  finally
    free;
  end;
end;

//lee un valor numrico de un fichero INI
function leNumINI (clave, cadena : string; defecto : Integer) : Integer;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadInteger (clave, cadena, defecto);
  finally
    free;
  end;
end;

//lee un valor string de un fichero INI
function leCadINI (clave, cadena : string; defecto : String) : String;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadString (clave, cadena, defecto);
  finally
    free;
  end;
end;

//escribe un valor string en un fichero INI
procedure esCadINI (clave, cadena : string; valor : String);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteString (clave, cadena, valor);
  finally
    free;
  end;
end;

//escribe un valor boolean en un fichero INI
procedure esBoolINI (clave, cadena : string; valor : Boolean);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteBool (clave, cadena, valor);
  finally
    free;
  end;
end;

//escribe un valor numrico en un fichero INI
procedure esNumINI (clave, cadena : string; valor : Integer);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteInteger (clave, cadena, valor);
  finally
    free;
  end;
end;


//encriptar datos
function encriptar(aStr: String; aKey: Integer): String;
begin
   Result:='';
   RandSeed:=aKey;
   for aKey:=1 to Length(aStr) do
       Result:=Result+Chr(Byte(aStr[aKey]) xor random(256));
end;

//desencriptar datos
function desencriptar(aStr: String; aKey: Integer): String;
begin
   Result := '';
   RandSeed := aKey;
   for aKey := 1 to Length(aStr) do
       Result := Result + Chr(Byte(aStr[aKey]) xor random(256));
end;



function obtenerCadenaRegistro (claveInicial : Cardinal; clave : string; valor : string) : string;
var
  reg: TRegistry;
begin
  Result := '';
  Reg := TRegistry.Create;
  Reg.RootKey := claveInicial;
  reg.OpenKey(clave, False);
  try
    Result := reg.ReadString(valor);
  finally
    reg.CloseKey;
  end;
end;

procedure obtenerDatosODBC (odbc : string; sistema : boolean;
    var bd : string; var tipo : string; var descripcion : string;
    var controlador : string; var servidor : string;
    var listener : string; var usuario : string);
var
  claveInicial : Cardinal;
begin
  bd := '';
  tipo := '';
  descripcion := '';
  controlador := '';
  servidor := '';
  listener := '';
  usuario := '';
  if sistema then
    claveInicial := HKEY_LOCAL_MACHINE
  else
    claveInicial := HKEY_CURRENT_USER;
  tipo := obtenerCadenaRegistro(claveInicial,'SOFTWARE\ODBC\ODBC.INI\ODBC Data Sources',odbc);

  //Oracle
  if pos ('ORACLE', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    listener := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'ServerName');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'UserID');
  end;
  //MySQL
  if pos ('MYSQL', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DESCRIPTION');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DATABASE');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    servidor := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'SERVER');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'UID');
  end;
  //MS Access
  if pos ('ACCESS', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DBQ');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'UID');
  end;
  //DBASE
  if pos ('DBASE', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
  end;
  //SQL SERVER
  if pos ('SQL SERVER', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    servidor := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Server');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'LastUser');
  end;
  //Paradox
  if pos ('PARADOX', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DefaultDir');
    servidor := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc + '\Engines\Paradox', 'ParadoxNetPath');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'LastUser');
  end;
  //Excel
  if pos ('EXCEL', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DBQ');
    servidor := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DefaultDir');
  end;
  //TEXT, CSV
  if pos ('TEXT', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DefaultDir');
  end;
end;

                   



end.
